dofile_once("mods/vergil_player_character/vergil_config.lua") -- This file is where you can toggle certain options.
function OnPlayerSpawned( player_entity ) -- This runs when player entity has been created
	-- random loadout compatibility fix
	if tonumber(StatsGetValue("playtime")) < 1 then

		ComponentSetValue( EntityGetFirstComponent( player_entity, "SpriteComponent" ), "image_file", "data/enemies_gfx/player.xml" )
		if HAT_TOGGLE == false and CAPE_TOGGLE == false then
			ComponentSetValue( EntityGetFirstComponent( player_entity, "DamageModelComponent" ), "ragdoll_filenames_file", "data/ragdolls/player/filenames.txt" )
		elseif HAT_TOGGLE == true and CAPE_TOGGLE == false then
			ComponentSetValue( EntityGetFirstComponent( player_entity, "DamageModelComponent" ), "ragdoll_filenames_file", "data/ragdolls/player/filenames_hat.txt" )
		elseif HAT_TOGGLE == false and CAPE_TOGGLE == true then
			ComponentSetValue( EntityGetFirstComponent( player_entity, "DamageModelComponent" ), "ragdoll_filenames_file", "data/ragdolls/player/filenames_cape.txt" )
		elseif HAT_TOGGLE == true and CAPE_TOGGLE == true then
			ComponentSetValue( EntityGetFirstComponent( player_entity, "DamageModelComponent" ), "ragdoll_filenames_file", "data/ragdolls/player/filenames_hat_and_cape.txt" )
		end

		-- Adds new hotspots
		EntityAddComponent( player_entity, "HotspotComponent",
			{
				_tags="bangs_root",
				sprite_hotspot_name="bangs"	
			} )

		-- Adds new verlet chain entities
		local px, py = EntityGetTransform( player_entity )
		local ent_bang1 = EntityLoad("data/entities/verlet_chains/megumin_bangs/verlet_bang1.xml",px, py)
		local ent_bang2 = EntityLoad("data/entities/verlet_chains/megumin_bangs/verlet_bang2.xml",px, py)
		local ent_bangC = EntityLoad("data/entities/verlet_chains/megumin_bangs/verlet_bangC.xml",px, py)
		local ent_bangL = EntityLoad("data/entities/verlet_chains/megumin_bangs/verlet_bangL.xml",px, py)
		local ent_bangR = EntityLoad("data/entities/verlet_chains/megumin_bangs/verlet_bangR.xml",px, py)

		EntityAddChild(player_entity, ent_bang1 )
		EntityAddChild(player_entity, ent_bang2 )
		EntityAddChild(player_entity, ent_bangC )	
		EntityAddChild(player_entity, ent_bangL )
		EntityAddChild(player_entity, ent_bangR )

			
		-- Adds stains for the extra sprites
		EntityAddComponent( player_entity, "SpriteStainsComponent",
		{
			sprite_id="1"
		} )
		EntityAddComponent( player_entity, "SpriteStainsComponent",
		{
			sprite_id="2"
		} )	
		EntityAddComponent( player_entity, "SpriteStainsComponent",
		{
			sprite_id="4"
		} )
		EntityAddComponent( player_entity, "SpriteStainsComponent",
		{
			sprite_id="6"
		} )
		
		-- Removes cape
		local plyChildEnt = EntityGetAllChildren( player_entity )
		if ( plyChildEnt ~= nil ) then
			for i,childEntity in ipairs( plyChildEnt ) do
				if ( EntityGetName( childEntity ) == "cape" ) then
					EntityKill( childEntity )
					break
				end
			end
		end


		if HAT_TOGGLE == true then	
			EntityAddComponent( player_entity, "SpriteComponent",
			{
				_tags="character, Megumin_Hat, hat_fix1",
				alpha="1", 
				image_file="data/enemies_gfx/player_hat.xml", 
				next_rect_animation="", 
				offset_x="6", 
				offset_y="14" ,
				rect_animation="walk",
				update_transform="1",                                               
				z_index="0.599"
			} )
			EntityAddComponent( player_entity, "SpriteComponent",
			{
				_tags="character, Megumin_Hat, hat_fix2",
				alpha="0", 
				image_file="data/enemies_gfx/player_hat2.xml", 
				next_rect_animation="", 
				offset_x="6", 
				offset_y="14" ,
				rect_animation="walk",
				update_transform="1",                                               
				z_index="0.599"
			} )
		end


		if CAPE_TOGGLE == true then	
				-- Adds cape entities
			local px, py = EntityGetTransform( player_entity )
			local ent_cape = EntityLoad("data/entities/verlet_chains/megumin_cape/megumin_cape.xml",px, py)    
			EntityAddChild(player_entity, ent_cape )	
			
			local px, py = EntityGetTransform( player_entity )
			local ent_cape = EntityLoad("data/entities/verlet_chains/megumin_cape/megumin_cape2.xml",px, py)    
			EntityAddChild(player_entity, ent_cape )
			
			local px, py = EntityGetTransform( player_entity )
			local ent_cape = EntityLoad("data/entities/verlet_chains/megumin_cape/megumin_cape3.xml",px, py)    
			EntityAddChild(player_entity, ent_cape )
			
			EntityAddComponent( player_entity, "SpriteComponent",
			{
				_tags="character, Megumin_Cape_Top, cape_top_fix1",
				alpha="1", 
				image_file="data/enemies_gfx/player_cape_top.xml", 
				next_rect_animation="", 
				offset_x="6", 
				offset_y="14" ,
				rect_animation="walk",
				z_index="0.598"
			} )
			EntityAddComponent( player_entity, "SpriteComponent",
			{
				_tags="character, Megumin_Cape_Top, cape_top_fix2",
				alpha="0", 
				image_file="data/enemies_gfx/player_cape_top.xml", 
				next_rect_animation="", 
				offset_x="6", 
				offset_y="14" ,
				rect_animation="walk",
				z_index="0.598"
			} )
		end
			

		if JETPACK_TOGGLE == true then
			EntitySetComponentsWithTagEnabled( player_entity, "jetpack", 1 )
			if( nil == EntityGetFirstComponent( player_entity, "ParticleEmitterComponent", "megumin_pt" ) ) then
				-- Remove old particles
				for i,compo in ipairs( {"ParticleEmitterComponent", "SpriteParticleEmitterComponent"} ) do
					while( compo ~= nil ) do
						local ptEmit = EntityGetFirstComponent( player_entity, compo, "jetpack" )
						if ( ptEmit == nil ) then break end
						EntityRemoveComponent( player_entity, ptEmit )
					end
				end
				-- Create new particles start
				local ptEmit1 = EntityAddComponent( player_entity, "ParticleEmitterComponent",
				{
					_tags="jetpack,megumin_pt",
					emitted_material_name="plasma_fading",
					x_pos_offset_min="-5",
					x_pos_offset_max="5",
					y_pos_offset_min="-5",
					y_pos_offset_max="5",
					x_vel_min="-8",
					x_vel_max="8",
					y_vel_min="-8",
					y_vel_max="8",
					count_min="2",
					count_max="5",
					attractor_force="0",
					lifetime_min="0.0",
					lifetime_max="15",
					create_real_particles="0",
					emit_cosmetic_particles="1",
					fade_based_on_lifetime="1",
					draw_as_long="1",
					emission_interval_min_frames="5",
					emission_interval_max_frames="5",
					is_trail="0",
					trail_gap="0.0",
					airflow_force="1.051",
					airflow_time="1.01",
					airflow_scale="0.05",
					is_emitting="1"
				} )
				
				local ptEmit2 = EntityAddComponent( player_entity, "ParticleEmitterComponent",
				{
					_tags="jetpack,megumin_pt",
					emitted_material_name="plasma_fading_pink",
					x_pos_offset_min="-5",
					x_pos_offset_max="5",
					y_pos_offset_min="-5",
					y_pos_offset_max="5",
					x_vel_min="-8",
					x_vel_max="8",
					y_vel_min="-8",
					y_vel_max="8",
					count_min="2",
					count_max="5",
					attractor_force="0",
					lifetime_min="0.0",
					lifetime_max="15",
					create_real_particles="0",
					emit_cosmetic_particles="1",
					fade_based_on_lifetime="1",
					draw_as_long="1",
					emission_interval_min_frames="5",
					emission_interval_max_frames="5",
					is_trail="0",
					trail_gap="0.0",
					airflow_force="1.051",
					airflow_time="1.01",
					airflow_scale="0.05",
					is_emitting="1"
				} )


				local ptx, pty = ComponentGetValueVector2( ptEmit1, "gravity" )
				local amn, amx = ComponentGetValueVector2( ptEmit1, "area_circle_radius" )
				pty = "0.0"
				amx = "0"
				ComponentSetValueVector2( ptEmit1, "gravity", ptx, pty )
				ComponentSetValueVector2( ptEmit2, "gravity", ptx, pty )
				ComponentSetValueVector2( ptEmit1, "offset", "-2", "2" )
				ComponentSetValueVector2( ptEmit2, "offset", "-2", "2" )
				ComponentSetValueVector2( ptEmit1, "area_circle_radius", amn, amx )
				ComponentSetValueVector2( ptEmit2, "area_circle_radius", amn, amx )
				-- Create new particles end
			end
		end
		
		--This fixes the teleportation glitch, don't turn it off until the devs fix this.
		if GAME_IS_FUCK == true then
			EntityAddComponent( player_entity, "LuaComponent",
			{
			  remove_after_executed="0",
			  execute_times="-1",
			  script_source_file="data/scripts/cape_fix.lua"
			} )
		end
		
		
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  eecute_times="-1",
		  script_source_file="data/scripts/velocity_fix.lua"
		} )
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  eecute_times="-1",
		  script_source_file="data/scripts/invisibility_fix.lua"
		} )
		EntityAddComponent( player_entity, "LuaComponent",
		{
		  remove_after_executed="0",
		  eecute_times="-1",
		  script_source_file="data/scripts/megumin_no_mana_timer.lua"
		} )
	end



end
